=== playground/exclusive_link/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2011 (ita)

VERSION='0.0.1'
APPNAME='cc_test'

top = '.'

def options(opt):
	opt.load('compiler_c')

def configure(conf):
	conf.load('compiler_c')
	conf.load('excl', tooldir='.')

def build(bld):
	for i in range(20):
		bld.program(source='main.c', target='app_%d' % i)
