=== playground/gdbus/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Copyright Garmin International or its subsidiaries, 2018

VERSION = '1.0'

def options(opt):
	opt.load('compiler_c')

def configure(conf):
	conf.load('compiler_c gdbus')
	conf.check_cfg(package='gio-2.0', args='--cflags --libs')
	conf.check_cfg(package='gio-unix-2.0', args='--cflags --libs')
	conf.check_cfg(package='glib-2.0', args='--cflags --libs')

def build(bld):
	tg = bld.program(
		includes = '.',
		source = bld.path.ant_glob('*.c'),
		target = 'gnome-hello',
		use = 'GIO-2.0 GIO-UNIX-2.0 GLIB-2.0')

	tg.add_gdbus_file('test.xml', 'test_prefix', 'glib_server')
